Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -1123,7 +1343,10 @@
 !> Scalar advection - Call for grid point i,j
 !------------------------------------------------------------------------------!
-    SUBROUTINE advec_s_ws_ij( i, j, sk, sk_char, swap_flux_y_local,            &
+    SUBROUTINE advec_s_ws_ij( advc_flag, i, j, sk, sk_char, swap_flux_y_local, &
                               swap_diss_y_local, swap_flux_x_local,            &
-                              swap_diss_x_local, i_omp, tn, flux_limitation )
+                              swap_diss_x_local, i_omp, tn,                    &
+                              non_cyclic_l, non_cyclic_n,                      &
+                              non_cyclic_r, non_cyclic_s,                      &
+                              flux_limitation )
 
 
@@ -1140,5 +1363,12 @@
        INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms  
        INTEGER(iwp) ::  tn        !< number of OpenMP thread
-
+       
+       INTEGER(iwp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::   &
+                                                  advc_flag !< flag array to control order of scalar advection
+
+       LOGICAL           ::  non_cyclic_l    !< flag that indicates non-cyclic boundary on the left
+       LOGICAL           ::  non_cyclic_n    !< flag that indicates non-cyclic boundary on the north
+       LOGICAL           ::  non_cyclic_r    !< flag that indicates non-cyclic boundary on the right
+       LOGICAL           ::  non_cyclic_s    !< flag that indicates non-cyclic boundary on the south                                           
        LOGICAL, OPTIONAL ::  flux_limitation !< flag indicating flux limitation of the vertical advection
        LOGICAL           ::  limiter         !< control flag indicating the application of flux limitation
@@ -1196,8 +1426,8 @@
 !--    instead of the entire subdomain. This should lead to better 
 !--    load balance between boundary and non-boundary PEs.
-       IF( ( bc_dirichlet_l  .OR.  bc_radiation_l )  .AND.  i <= nxl + 2  .OR. &
-           ( bc_dirichlet_r  .OR.  bc_radiation_r )  .AND.  i >= nxr - 2  .OR. &
-           ( bc_dirichlet_s  .OR.  bc_radiation_s )  .AND.  j <= nys + 2  .OR. &
-           ( bc_dirichlet_n  .OR.  bc_radiation_n )  .AND.  j >= nyn - 2 )  THEN
+       IF( non_cyclic_l  .AND.  i <= nxl + 2  .OR.                             &
+           non_cyclic_r  .AND.  i >= nxr - 2  .OR.                             &
+           non_cyclic_s  .AND.  j <= nys + 2  .OR.                             &
+           non_cyclic_n  .AND.  j >= nyn - 2 )  THEN
           nzb_max_l = nzt
        ELSE
@@ -1215,7 +1445,7 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit5 = REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )
-             ibit4 = REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )
-             ibit3 = REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )
+             ibit5 = REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )
+             ibit4 = REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )
+             ibit3 = REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )
 
              v_comp                  = v(k,j,i) - v_gtrans + v_stokes_zu(k)
@@ -1276,7 +1506,7 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit2 = REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )
-             ibit1 = REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )
-             ibit0 = REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )
+             ibit2 = REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )
+             ibit1 = REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )
+             ibit0 = REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )
 
              u_comp                     = u(k,j,i) - u_gtrans + u_stokes_zu(k)
@@ -1340,7 +1570,7 @@
 !--       flux at the end. 
 
-          ibit2 = REAL( IBITS(advc_flags_1(k,j,i),2,1), KIND = wp )
-          ibit1 = REAL( IBITS(advc_flags_1(k,j,i),1,1), KIND = wp )
-          ibit0 = REAL( IBITS(advc_flags_1(k,j,i),0,1), KIND = wp )
+          ibit2 = REAL( IBITS(advc_flag(k,j,i),2,1), KIND = wp )
+          ibit1 = REAL( IBITS(advc_flag(k,j,i),1,1), KIND = wp )
+          ibit0 = REAL( IBITS(advc_flag(k,j,i),0,1), KIND = wp )
 
           u_comp    = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
@@ -1375,7 +1605,7 @@
                                        )
 
-          ibit5 = REAL( IBITS(advc_flags_1(k,j,i),5,1), KIND = wp )
-          ibit4 = REAL( IBITS(advc_flags_1(k,j,i),4,1), KIND = wp )
-          ibit3 = REAL( IBITS(advc_flags_1(k,j,i),3,1), KIND = wp )
+          ibit5 = REAL( IBITS(advc_flag(k,j,i),5,1), KIND = wp )
+          ibit4 = REAL( IBITS(advc_flag(k,j,i),4,1), KIND = wp )
+          ibit3 = REAL( IBITS(advc_flag(k,j,i),3,1), KIND = wp )
 
           v_comp    = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
@@ -1445,11 +1675,11 @@
 !--    calculated explicetely for the tendency at
 !--    the first w-level. For topography wall this is done implicitely by
-!--    advc_flags_1.
+!--    advc_flag.
        flux_t(nzb) = 0.0_wp
        diss_t(nzb) = 0.0_wp
        DO  k = nzb+1, nzb+2
-          ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
-          ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
-          ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+          ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 !
 !--       k index has to be modified near bottom and top, else array
@@ -1491,7 +1721,7 @@
        
        DO  k = nzb+3, nzt-2
-          ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
-          ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
-          ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+          ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 
           flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                            &
@@ -1526,7 +1756,7 @@
        
        DO  k = nzt-1, nzt
-          ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
-          ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
-          ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+          ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 !
 !--       k index has to be modified near bottom and top, else array
@@ -1675,15 +1905,15 @@
           diss_d    = diss_t(k-1)
           
-          ibit2 = REAL( IBITS(advc_flags_1(k,j,i),2,1), KIND = wp )
-          ibit1 = REAL( IBITS(advc_flags_1(k,j,i),1,1), KIND = wp )
-          ibit0 = REAL( IBITS(advc_flags_1(k,j,i),0,1), KIND = wp )
+          ibit2 = REAL( IBITS(advc_flag(k,j,i),2,1), KIND = wp )
+          ibit1 = REAL( IBITS(advc_flag(k,j,i),1,1), KIND = wp )
+          ibit0 = REAL( IBITS(advc_flag(k,j,i),0,1), KIND = wp )
           
-          ibit5 = REAL( IBITS(advc_flags_1(k,j,i),5,1), KIND = wp )
-          ibit4 = REAL( IBITS(advc_flags_1(k,j,i),4,1), KIND = wp )
-          ibit3 = REAL( IBITS(advc_flags_1(k,j,i),3,1), KIND = wp )
+          ibit5 = REAL( IBITS(advc_flag(k,j,i),5,1), KIND = wp )
+          ibit4 = REAL( IBITS(advc_flag(k,j,i),4,1), KIND = wp )
+          ibit3 = REAL( IBITS(advc_flag(k,j,i),3,1), KIND = wp )
           
-          ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
-          ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
-          ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+          ibit8 = REAL( IBITS(advc_flag(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flag(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flag(k,j,i),6,1), KIND = wp )
 !
 !--       Calculate the divergence of the velocity field. A respective
@@ -1692,14 +1922,14 @@
           div         =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )            &
                           - u(k,j,i)   * (                                    &
-                        REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )   &
+                        REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )      &
+                      + REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )      &
+                      + REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )      &
                                          )                                    &
                           ) * ddx                                             &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )            &
                           - v(k,j,i)   * (                                    &
-                        REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )   &
+                        REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )      &
+                      + REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )      &
+                      + REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )      &
                                          )                                    &
                           ) * ddy                                             &
@@ -1708,7 +1938,7 @@
                           - w(k-1,j,i) * rho_air_zw(k-1) *                    &
                                          (                                    &
-                        REAL( IBITS(advc_flags_1(k-1,j,i),6,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_1(k-1,j,i),7,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_1(k-1,j,i),8,1), KIND = wp )   &
+                        REAL( IBITS(advc_flag(k-1,j,i),6,1), KIND = wp )      &
+                      + REAL( IBITS(advc_flag(k-1,j,i),7,1), KIND = wp )      &
+                      + REAL( IBITS(advc_flag(k-1,j,i),8,1), KIND = wp )      &
                                          )                                    &      
                           ) * drho_air(k) * ddzw(k)
@@ -1897,13 +2127,13 @@
        INTEGER(iwp) ::  tn        !< number of OpenMP thread
        
-       REAL(wp)    ::  ibit9    !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit10   !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit11   !< flag indicating 5th-order scheme along x-direction
-       REAL(wp)    ::  ibit12   !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit13   !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit14   !< flag indicating 5th-order scheme along y-direction
-       REAL(wp)    ::  ibit15   !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)    ::  ibit16   !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)    ::  ibit17   !< flag indicating 5th-order scheme along z-direction
+       REAL(wp)    ::  ibit0   !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit1   !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit2   !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit3   !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit4   !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit5   !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit6   !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit7   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit8   !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d   !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div      !< diverence on u-grid
@@ -1944,37 +2174,37 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit14 = REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )
-             ibit13 = REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )
-             ibit12 = REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )
+             ibit5 = REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )
+             ibit4 = REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )
+             ibit3 = REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )
 
              v_comp(k)      = v(k,j,i) + v(k,j,i-1) - gv
-             flux_s_u(k,tn) = v_comp(k) * (                                   &
-                            ( 37.0_wp * ibit14 * adv_mom_5                    &
-                         +     7.0_wp * ibit13 * adv_mom_3                    &
-                         +              ibit12 * adv_mom_1                    &
-                            ) *                                               &
-                                        ( u(k,j,i)   + u(k,j-1,i) )           &
-                     -      (  8.0_wp * ibit14 * adv_mom_5                    &
-                         +              ibit13 * adv_mom_3                    &
-                            ) *                                               &
-                                        ( u(k,j+1,i) + u(k,j-2,i) )           &
-                     +      (           ibit14 * adv_mom_5                    &
-                            ) *                                               &
-                                        ( u(k,j+2,i) + u(k,j-3,i) )           &
+             flux_s_u(k,tn) = v_comp(k) * (                                    &
+                            ( 37.0_wp * ibit5 * adv_mom_5                      &
+                         +     7.0_wp * ibit4 * adv_mom_3                      &
+                         +              ibit3 * adv_mom_1                      &
+                            ) *                                                &
+                                        ( u(k,j,i)   + u(k,j-1,i) )            &
+                     -      (  8.0_wp * ibit5 * adv_mom_5                      &
+                         +              ibit4 * adv_mom_3                      &
+                            ) *                                                &
+                                        ( u(k,j+1,i) + u(k,j-2,i) )            &
+                     +      (           ibit5 * adv_mom_5                      &
+                            ) *                                                &
+                                        ( u(k,j+2,i) + u(k,j-3,i) )            &
                                           )
 
-             diss_s_u(k,tn) = - ABS ( v_comp(k) ) * (                         &
-                            ( 10.0_wp * ibit14 * adv_mom_5                    &
-                         +     3.0_wp * ibit13 * adv_mom_3                    &
-                         +              ibit12 * adv_mom_1                    &
-                            ) *                                               &
-                                        ( u(k,j,i)   - u(k,j-1,i) )           &
-                     -      (  5.0_wp * ibit14 * adv_mom_5                    &
-                         +              ibit13 * adv_mom_3                    &
-                            ) *                                               &
-                                        ( u(k,j+1,i) - u(k,j-2,i) )           &
-                     +      (           ibit14 * adv_mom_5                    &
-                            ) *                                               &
-                                        ( u(k,j+2,i) - u(k,j-3,i) )           &
+             diss_s_u(k,tn) = - ABS ( v_comp(k) ) * (                          &
+                            ( 10.0_wp * ibit5 * adv_mom_5                      &
+                         +     3.0_wp * ibit4 * adv_mom_3                      &
+                         +              ibit3 * adv_mom_1                      &
+                            ) *                                                &
+                                        ( u(k,j,i)   - u(k,j-1,i) )            &
+                     -      (  5.0_wp * ibit5 * adv_mom_5                      &
+                         +              ibit4 * adv_mom_3                      &
+                            ) *                                                &
+                                        ( u(k,j+1,i) - u(k,j-2,i) )            &
+                     +      (           ibit5 * adv_mom_5                      &
+                            ) *                                                &
+                                        ( u(k,j+2,i) - u(k,j-3,i) )            &
                                                     )
 
@@ -1984,11 +2214,11 @@
 
              v_comp(k)      = v(k,j,i) + v(k,j,i-1) - gv
-             flux_s_u(k,tn) = v_comp(k) * (                                   &
-                           37.0_wp * ( u(k,j,i) + u(k,j-1,i)   )              &
-                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )              &
-                         +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
-             diss_s_u(k,tn) = - ABS(v_comp(k)) * (                            &
-                           10.0_wp * ( u(k,j,i) - u(k,j-1,i)   )              &
-                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )              &
+             flux_s_u(k,tn) = v_comp(k) * (                                    &
+                           37.0_wp * ( u(k,j,i)   + u(k,j-1,i)   )             &
+                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )               &
+                         +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5 
+             diss_s_u(k,tn) = - ABS(v_comp(k)) * (                             &
+                           10.0_wp * ( u(k,j,i)   - u(k,j-1,i)   )             &
+                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )               &
                          +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
 
@@ -2002,50 +2232,50 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit11 = REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )
-             ibit10 = REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )
-             ibit9  = REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )
-
-             u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
-             flux_l_u(k,j,tn) = u_comp_l * (                                  &
-                              ( 37.0_wp * ibit11 * adv_mom_5                  &
-                           +     7.0_wp * ibit10 * adv_mom_3                  &
-                           +              ibit9  * adv_mom_1                  &
-                              ) *                                             &
-                                          ( u(k,j,i)   + u(k,j,i-1) )         &
-                       -      (  8.0_wp * ibit11 * adv_mom_5                  &
-                           +              ibit10 * adv_mom_3                  &
-                              ) *                                             &
-                                          ( u(k,j,i+1) + u(k,j,i-2) )         &
-                       +      (           ibit11 * adv_mom_5                  &
-                              ) *                                             &
-                                          ( u(k,j,i+2) + u(k,j,i-3) )         &
-                                           )
-
-              diss_l_u(k,j,tn) = - ABS( u_comp_l ) * (                        &
-                              ( 10.0_wp * ibit11 * adv_mom_5                  &
-                           +     3.0_wp * ibit10 * adv_mom_3                  &
-                           +              ibit9  * adv_mom_1                  &
-                              ) *                                             &
-                                        ( u(k,j,i)   - u(k,j,i-1) )           &
-                       -      (  5.0_wp * ibit11 * adv_mom_5                  &
-                           +              ibit10 * adv_mom_3                  &
-                              ) *                                             &
-                                        ( u(k,j,i+1) - u(k,j,i-2) )           &
-                       +      (           ibit11 * adv_mom_5                  &
-                              ) *                                             &
-                                        ( u(k,j,i+2) - u(k,j,i-3) )           &
-                                                     )
-
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt
+             ibit2 = REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )
+             ibit1 = REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )
+             ibit0 = REAL( IBITS(advc_flags_m(k,j,i-1),0,1), KIND = wp )
 
              u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
              flux_l_u(k,j,tn) = u_comp_l * (                                   &
-                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )             &
+                              ( 37.0_wp * ibit2 * adv_mom_5                    &
+                           +     7.0_wp * ibit1 * adv_mom_3                    &
+                           +              ibit0 * adv_mom_1                    &
+                              ) *                                              &
+                                          ( u(k,j,i)   + u(k,j,i-1) )          &
+                       -      (  8.0_wp * ibit2 * adv_mom_5                    &
+                           +              ibit1 * adv_mom_3                    &
+                              ) *                                              &
+                                          ( u(k,j,i+1) + u(k,j,i-2) )          &
+                       +      (           ibit2 * adv_mom_5                    &
+                              ) *                                              &
+                                          ( u(k,j,i+2) + u(k,j,i-3) )          &
+                                           )                                  
+                                                                              
+              diss_l_u(k,j,tn) = - ABS( u_comp_l ) * (                         &
+                              ( 10.0_wp * ibit2 * adv_mom_5                    &
+                           +     3.0_wp * ibit1 * adv_mom_3                    &
+                           +              ibit0  * adv_mom_1                   &
+                              ) *                                              &
+                                        ( u(k,j,i)   - u(k,j,i-1) )            &
+                       -      (  5.0_wp * ibit2 * adv_mom_5                    &
+                           +              ibit1 * adv_mom_3                    &
+                              ) *                                              &
+                                        ( u(k,j,i+1) - u(k,j,i-2) )            &
+                       +      (           ibit2 * adv_mom_5                    &
+                              ) *                                              &
+                                        ( u(k,j,i+2) - u(k,j,i-3) )            &
+                                                     )
+
+          ENDDO
+
+          DO  k = nzb_max_l+1, nzt
+
+             u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
+             flux_l_u(k,j,tn) = u_comp_l * (                                   &
+                             37.0_wp * ( u(k,j,i)   + u(k,j,i-1)   )           &
                            -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )             &
                            +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
              diss_l_u(k,j,tn) = - ABS(u_comp_l) * (                            &
-                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )             &
+                             10.0_wp * ( u(k,j,i)   - u(k,j,i-1)   )           &
                            -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )             &
                            +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
